#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXS = 100;
const int MAXA = 200;

enum Categoria {HOBBY, AUTO, CASA, SPORT};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Annuncio {
  Categoria cat;
  Data pub;
  float prezzo;
  char descr[MAXS];
};

struct ArchivioAnn {
  Annuncio ann[MAXA];
  int numAnn;
};


bool piuNumerosa(const ArchivioAnn* pa, Categoria* pc);
float prezzoMedio(const ArchivioAnn* pa, Categoria c);
int seleziona(const ArchivioAnn* pa, const char p[], Annuncio v[]);
bool salva(const ArchivioAnn* pa, const char n[]);
void stampa(const ArchivioAnn* pa);

bool inserisci(ArchivioAnn* pa, Annuncio a) {
  if(pa->numAnn == MAXA) return false;
  pa->ann[pa->numAnn] = a;
  pa->numAnn++;
  return true;
}

Categoria leggiCat(){
  cout << "Categoria (h/a/c/s)? ";
  char c;
  cin >> c;
  switch(c) {
    case 'h': return HOBBY;
    case 'a': return AUTO;
    case 'c': return CASA;
    case 's': return SPORT; 
  }
}

Annuncio leggiAnnuncio() {
  Annuncio a;
  a.cat = leggiCat();
  cout << "Prezzo? ";
  cin >> a.prezzo;
  cout << "Data: giorno? ";
  cin >> a.pub.giorno;
  cout << "Data: mese? ";
  cin >> a.pub.mese;
  cout << "Data: anno? ";
  cin >> a.pub.anno;
  cout << "Descrizione? ";
  cin.ignore();
  cin.getline(a.descr, MAXS);
  return a;
}

void menu(){
  cout << "-------------------------" << endl;
  cout << "0) inserisci" << endl;
  cout << "1) piu' numerosa" << endl;
  cout << "2) prezzo medio" << endl;
  cout << "3) seleziona" << endl;
  cout << "4) salva" << endl;
  cout << "5) stampa" << endl;
  cout << "6) esci" << endl;
  cout << "? ";
}

int main(){
  ArchivioAnn ar;
  ar.numAnn = 0;
    
  char s;
  Annuncio a;
  Annuncio v[MAXA];
  bool res;
  Categoria x;
  const char* st[] = {"hobby", "auto", "casa", "sport"};
  float pm;
  int k;
  char par[MAXS];

  while(true) {
    menu();
    cin >> s;
    switch(s) {
      case '0':
        a = leggiAnnuncio();
        res = inserisci(&ar, a);
        if(res) cout << "Inserimento ok"<< endl;
        else cout << "Non inserito" << endl;
        break;
      case '1':
        res = piuNumerosa(&ar, &x);
        if(res) cout << st[x] << endl; 
        else cout << "Archivio vuoto" << endl;
        break;
      case '2':
        x = leggiCat();
        pm = prezzoMedio(&ar, x);
        cout << pm << endl; 
        break;
      case '3':
        cout << "Parola? ";
        cin >> par;
        k = seleziona(&ar, par, v);
        cout << "Sono stati selezionati " << k << " annunci" << endl;
        break;
      case '4':
        res = salva(&ar, "out.txt");
        if(res) cout << "Salvataggio ok" << endl;
        else cout << "Problemi..." << endl;
        break;
      case '5':
        stampa(&ar);
        break;
      case '6':
        return 0;
        break;
    }
  }
}
