#include <iostream>
#include <fstream>
#include <cstring>
using namespace std;

const int MAXS = 100;
const int MAXA = 200;

enum Categoria {HOBBY, AUTO, CASA, SPORT};

struct Data {
  int giorno;
  int mese;
  int anno;
};

struct Annuncio {
  Categoria cat;
  Data pub;
  float prezzo;
  char descr[MAXS];
};

struct ArchivioAnn {
  Annuncio ann[MAXA];
  int numAnn;
};


bool piuNumerosa(const ArchivioAnn* pa, Categoria* pc) {
  if(pa->numAnn == 0)
    return false;
  int c[4] = {0};
  for(int i=0; i<pa->numAnn; i++) {
    c[pa->ann[i].cat]++;
  }
  int m = 0;
  Categoria x;
  for(int i=0; i<4; i++) {
    if(m<c[i]) {
      m = c[i];
      x = (Categoria) i;
    }
  }
  *pc = x;
  return true;
}

float prezzoMedio(const ArchivioAnn* pa, Categoria c) {
  float s = 0;
  int conta = 0;
  for(int i=0; i<pa->numAnn; i++)
    if(pa->ann[i].cat == c) {
      conta++;  
      s += pa->ann[i].prezzo;
    }
  if(conta>0) 
    s = s/conta;
  return s;
}

int seleziona(const ArchivioAnn* pa, const char p[], Annuncio v[]) {
  int conta = 0;
  for(int i=0; i<pa->numAnn; i++)
    if(strstr(pa->ann[i].descr, p) > 0)
      v[conta++] = pa->ann[i];
  return conta;
}

int confronta(Data a, Data b) {
  if(a.anno != b.anno) return a.anno - b.anno;
  if(a.mese != b.mese) return a.mese - b.mese;
  return a.giorno - b.giorno; 
}

void ordina(Annuncio v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i; j<n; j++) {
      if(confronta(v[i].pub, v[j].pub) > 0) 
        index = j;
    }
    Annuncio tmp = v[i];
    v[i] = v[index];
    v[index] = tmp;
  }
}

bool salva(const ArchivioAnn* pa, const char n[]) {
  fstream f;
  f.open(n, ios::out);
  if(!f)
    return false;
  Annuncio aux[MAXA];
  for(int i=0; i<pa->numAnn; i++)
    aux[i] = pa->ann[i];
  ordina(aux, pa->numAnn); 
  for(int i=0; i<pa->numAnn; i++) {
    f << aux[i].pub.giorno << '/' << aux[i].pub.mese << '/' << aux[i].pub.anno << '\t';
    switch(aux[i].cat) {
      case HOBBY: f << "hobby"; break;
      case AUTO: f << "auto"; break;
      case CASA: f << "casa"; break;
      case SPORT: f << "sport"; break; 
    } 
    f << '\t' << aux[i].prezzo << '\t' << aux[i].descr << endl;
  }
}

void stampa(Annuncio a, float pm) {
  if(pm > a.prezzo) cout << '-';
  else if(pm == a.prezzo) cout << '=';
  else cout << '+';
  cout << ' ' << a.prezzo << '\t' << a.descr << endl;
}

void stampa(const ArchivioAnn* pa) {
  float me[4] = {0};
  for(int i=0; i<4; i++)
    me[i] = prezzoMedio(pa, (Categoria) i);
  for(int i=0; i<pa->numAnn; i++) {
    float pm = me[pa->ann[i].cat];
    stampa(pa->ann[i], pm);
  }
}
